.586
.model flat, stdcall


include windows.inc
include macros.def
include kernel32.inc
includelib kernel32.lib

comment		^

	LZW Packer 
	Coded by The Dude of Dudes

	Drag the file to pack/unpack onto LZW_Packer.exe's icon
		^

.data

szFilename	db	256	dup	(?)
Pack = TRUE
UnPack = FALSE
.data
	FileExtension	dd	?
.code
	LZW_Compress	proto, :dword, :dword, :dword
	LZW_DeCompress	proto, :dword, :dword, :dword

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PackFile	proc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


	local 	hReadFile:		dword
	local 	pReadFile:		dword
	local	hWriteFile:		dword
	local	pWriteFile:		dword
	local 	FileSize:		dword
	local	BytesWritten:		dword
	local	PackMode:		dword
	local	FileType:		dword

   ;--- Get Filename ---
	invoke GetCommandLine

	mov edi, eax
	mov ecx, 256 	;max filepath 256 bytes
	cld
	mov al, 0
	repne scasb
	sub edi, 2		;ptr to end of filename
	push edi
	mov ecx, 256
	mov al, ":"
	std
	repne scasb
	mov esi, edi
	pop ecx
	sub ecx, edi
	mov edi, offset szFilename
	cld
	rep movsb
	mov byte ptr [edi], 0		;add NULL

   ;--- Determine file extension and Packing Mode ---
	sub edi, 4
	push edi		;save for after packing/unpacking

	mov eax, dword ptr[edi]	
	mov FileExtension, eax	

	.if dword ptr[edi] == "wzl."
		mov PackMode, UnPack
	.else
		mov PackMode, Pack
	.endif



   ;---- Open File For Reading and Map entire contents into Memory---
	invoke CreateFile, addr szFilename, GENERIC_READ or GENERIC_WRITE, \
		NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	.if eax == INVALID_HANDLE_VALUE
		jmp ExitOnError
	.endif

	mov hReadFile, eax

	invoke GetFileSize, hReadFile, NULL
	mov FileSize, eax
	invoke VirtualAlloc, NULL, eax, MEM_COMMIT, PAGE_READWRITE
	mov pReadFile, eax
	
	invoke ReadFile, hReadFile, pReadFile, FileSize, addr BytesWritten, NULL
	invoke CloseHandle, hReadFile
	mov eax, pReadFile
	add eax, FileSize

   ;--- Get Heap space for destinaton Buffer ---
	mov eax, FileSize
	shl eax, 2		;4 times source file
	invoke VirtualAlloc, NULL, eax, MEM_COMMIT, PAGE_READWRITE
	mov pWriteFile, eax

   ;--- Do some RLE ---
	.if PackMode == Pack
		invoke LZW_Compress, pReadFile, pWriteFile, FileSize
		mov FileSize, eax	;bytes to write
		pop edi
		mov eax, dword ptr[edi]
		mov FileType, eax
		mov dword ptr[edi], "wzl."

		;---- Create Destination File  ---
		invoke CreateFile, addr szFilename, GENERIC_READ or GENERIC_WRITE , NULL, \
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
		mov hWriteFile, eax
		
		;--- Add file type to start of file ---
		invoke WriteFile, hWriteFile, addr FileType, 4, addr BytesWritten, NULL
		
	.else
		;--- Get original Filetype from .rle file ---
		mov edi, pReadFile
		mov eax, [edi]
		mov FileType, eax
		add pReadFile, 4
		mov edi, FileSize
		sub edi, 4
		invoke LZW_DeCompress, pReadFile, pWriteFile, edi
		mov FileSize, eax	;bytes to write
		pop edi
		mov eax, FileType
		mov dword ptr[edi], eax		;original file type

		;---- Create Destination File  ---
		invoke CreateFile, addr szFilename, GENERIC_READ or GENERIC_WRITE , NULL, \
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
		mov hWriteFile, eax
		
	.endif
   

	invoke WriteFile, hWriteFile, pWriteFile, FileSize, addr BytesWritten, NULL
	invoke CloseHandle, hWriteFile
	
	invoke VirtualFree, pReadFile, NULL, MEM_RELEASE
	invoke VirtualFree, pWriteFile, NULL, MEM_RELEASE

ExitOnError:

	invoke ExitProcess, NULL

PackFile endp

include LZW_16bit.asm		;compression code
;~~~~~~~~~~~~~~
end PackFile
;~~~~~~~~~~~~~~